## ros-humble-create-driver 3.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(create_driver)

set(CMAKE_CXX_STANDARD 14)

add_compile_options(-Wall -Wextra -Wpedantic)

find_package(libcreate REQUIRED)

find_package(ament_cmake REQUIRED)
find_package(create_msgs REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(diagnostic_updater REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_ros REQUIRED)

include_directories(
  include
  ${libcreate_INCLUDE_DIRS}
)

add_executable(${PROJECT_NAME} src/${PROJECT_NAME}.cpp)
ament_target_dependencies(${PROJECT_NAME}
  create_msgs
  diagnostic_msgs
  diagnostic_updater
  geometry_msgs
  libcreate
  nav_msgs
  rclcpp
  sensor_msgs
  std_msgs
  tf2_geometry_msgs
  tf2_ros
)

if(BUILD_TESTING)
  # Skip copyright lint and uncrustify
  set(ament_cmake_copyright_FOUND TRUE)
  set(ament_cmake_uncrustify_FOUND TRUE)
  # Set language to C++, otherwise cppcheck assumes header file with .h is C
  set(ament_cmake_cppcheck_LANGUAGE c++)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

install(TARGETS ${PROJECT_NAME}
  DESTINATION lib/${PROJECT_NAME}
)

install(DIRECTORY include/
  DESTINATION include
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

ament_package()

=== debian/changelog ===
ros-humble-create-driver (3.1.0-1jammy) jammy; urgency=high

  * Fix compilation for ROS Humble
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Sun, 21 May 2023 07:00:00 -0000

ros-humble-create-driver (3.0.0-1jammy) jammy; urgency=high

  * Replace Travis CI with GitHub workflow and lint (#102 <https://github.com/autonomylab/create_robot/issues/102>)
  * Update maintainer email
  * Add parameter to enable the OI mode reporting bug workaround (#95 <https://github.com/autonomylab/create_robot/issues/95>)
  * Add cliff sensors (#93 <https://github.com/autonomylab/create_robot/issues/93>)
  * Add motor control (#97 <https://github.com/autonomylab/create_robot/issues/97>)
  * Disable libcreate's signal handler (#89 <https://github.com/autonomylab/create_robot/issues/89>)
  * Use rclcpp::spin instead of own implementation.
  * Use Node::now instead of rclcpp::Clock::now.
  * Make CreateDriver derive from rclcpp::Node.
  * Fix latching condition (#72 <https://github.com/autonomylab/create_robot/issues/72>)
  * Port to ROS 2 (foxy) (#8 <https://github.com/autonomylab/create_robot/issues/8>)
  * Stricter compile options
  * Switch to tf2
  * Reduce diagonal covariance values
  * Remove old install commands
  * Move launch and config files to create_bringup
  * Update maintainer info
  * Fix catkin lint error
  * Rename packages for clarity
    Originally the packages were named as 'create_autonomy', with the 'ca_' suffix for short.
    This was due to a name conflict with the turtlebot packages (e.g. create_driver and create_description):
    https://github.com/turtlebot/turtlebot_create.git
    Since the turtlebot packages are not released into ROS Melodic, the plan is to release these packages instead.
    If the turtlebot packages are eventually released, it should be straightforward to adapt them to use the
    description and driver packages here.
    Summary of renaming:
    * create_autonomy -> create_robot
    * ca_description -> create_description
    * ca_driver -> create_driver
    * ca_msgs -> create_msgs
    * ca_tools -> create_bringup
  * Contributors: Jacob Perron, Josh Gadeken, Owen Hooper, Pedro Grojsgold, pgold

 -- Jacob Perron <jacobmperron@gmail.com>  Sat, 13 May 2023 07:00:00 -0000

ros-humble-create-driver (1.3.0-1jammy) jammy; urgency=high

  * Add explicit dependency on catkin_EXPORTED_TARGETS
    
    This ensures ca_msgs is built before ca_driver.
  * Migrate to package.xml format 2
    
    Minor linting to package files.
  * Add roslint test and fix lint issues
  * find_package libcreate instead of downloading as external project
  * Add support for defining and playing songs
  * Update install rules
  * Refactor launch files and expose robot base and odometry frame IDs as parameters
  * Refactor CMakeLists.txt and package.xml files and add missing install rules
  * Contributors: Clyde McQueen, Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Sun, 10 Jun 2018 07:00:00 -0000

ros-humble-create-driver (1.2.0-1jammy) jammy; urgency=high

  * Add support for more than two robot models and fix compiling with latest changes from libcreate.
  * Contributors: Ben Wolsieffer

 -- Jacob Perron <jacobmperron@gmail.com>  Fri, 07 Oct 2016 07:00:00 -0000

ros-humble-create-driver (1.1.0-1jammy) jammy; urgency=high

  * Add diagnostics (Battery, Safety, Serial, Mode, Driver)
  * Refactor URDF to support differences between Create 1 and 2, while using a common base.
  * Include a mesh for the Create 1, borrowed from turtlebot_create.
  * Update launch files to support Create 1.
  * Publish JointState messages for the wheels.
  * Contributors: Ben Wolsieffer, Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Sat, 23 Jul 2016 07:00:00 -0000

ros-humble-create-driver (1.0.1-1jammy) jammy; urgency=high

  * Get pose covariance from underlying library
  * Make publishing TF (odom frame) optional
  * Add launch file argument making description optional
  * Update libcreate tag, with odometry patch
  * Add git as build dependency
  * Move ChargingState publisher with other battery state information
  * Add Bumper message with contact sensor states and light sensor states
  * Add header to all custom message types
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Tue, 24 May 2016 07:00:00 -0000

ros-humble-create-driver (1.0.0-1jammy) jammy; urgency=high

  * Update libcreate git tag
  * Rename variables according to ROS cpp style guide
  * Run clang-format
  * Fix typo
  * Add ca_description as runtime dependency to ca_driver
  * Change message type of various battery info topics
  * Add ChargingState and Mode messages
  * Add charging state and mode publishers
  * Add 'ca_msgs' package
  * Update ca_driver README.md
  * Rename 'create_driver' and 'create_tools' to 'ca_driver' and 'ca_tools'
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Fri, 01 Apr 2016 07:00:00 -0000

ros-humble-create-driver (0.4.0-1jammy) jammy; urgency=high

  * Add timestamp to odometry message
  * Update libcreate tag (with odometry fix)
  * Fix sign error for battery current and temperature
  * Update tag for libcreate
  * Add delay before starting dock demo in case of Create 1
  * Compute and publish battery charge ratio
  * Add README.md for create_driver
  * Add support for Create 1
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Sat, 26 Mar 2016 07:00:00 -0000

ros-humble-create-driver (0.3.0-1jammy) jammy; urgency=high

  * Add dock / undock support
  * Publish characters received by omni directional IR sensor
  * Add battery info support
  * Contributors: Jacob Perron

 -- Jacob Perron <jacobmperron@gmail.com>  Thu, 17 Mar 2016 07:00:00 -0000

ros-humble-create-driver (0.2.0-1jammy) jammy; urgency=high

  * Add covariances to odometry messages
  * Add set 7Seg display with ASCII
  * Add LED support
  * Add publishers for button presses
  * Contributors: Jacob Perron



=== debian/control ===
Source: ros-humble-create-driver
Section: misc
Priority: optional
Maintainer: Jacob Perron <jacobmperron@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-create-msgs, ros-humble-diagnostic-msgs, ros-humble-diagnostic-updater, ros-humble-geometry-msgs, ros-humble-libcreate, ros-humble-nav-msgs, ros-humble-rclcpp, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-tf2-geometry-msgs, ros-humble-tf2-ros, ros-humble-ros-workspace
Homepage: http://wiki.ros.org/create_driver
Standards-Version: 3.9.2

Package: ros-humble-create-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-create-msgs, ros-humble-diagnostic-msgs, ros-humble-diagnostic-updater, ros-humble-geometry-msgs, ros-humble-libcreate, ros-humble-nav-msgs, ros-humble-rclcpp, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-tf2-geometry-msgs, ros-humble-tf2-ros, ros-humble-ros-workspace
Description: ROS driver for iRobot's Create and Roomba platforms, based on libcreate

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-create-driver//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
